<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="d-flex flex-column">
  <div class="w-100">
    <!-- FIXME - show checkbox when we can filter desks with delegations -->
    <!-- -->
    <!--    <div class="form-group">-->
    <!--      <label [innerText]="messages.DASHBOARD_SHOW_DELEGATIONS"></label>-->
    <!--      <div>-->
    <!--        <button-->
    <!--          class="btn btn-outline-primary pe-4 ps-4"-->
    <!--          [ngClass]="{'active': !!userPreferences.showDelegations}"-->
    <!--          (click)="userPreferences.showDelegations = true"-->
    <!--          [innerText]="messages.SHOW">-->
    <!--        </button>-->
    <!--        <button-->
    <!--          class="btn btn-outline-primary ms-1 pe-4 ps-4"-->
    <!--          [ngClass]="{'active': !userPreferences.showDelegations}"-->
    <!--          (click)="userPreferences.showDelegations = false"-->
    <!--          [innerText]="messages.DO_NOT_SHOW">-->
    <!--        </button>-->
    <!--      </div>-->
    <!--    </div>-->

    <div *ngIf="showResultsPerPage()" class="form-group">
      <label
        for="resultsPerPageInput"
        [innerText]="messages.DASHBOARD_RESULTS_PER_PAGE">
      </label>
      <ng-select
        id="resultsPerPageInput"
        class="settings-select"
        [clearable]="false"
        [(ngModel)]="userPreferences.taskViewDefaultPageSize">
        <ng-option
          *ngFor="let number of possibleResultsPerPage"
          [value]="number"
          [innerText]="number">
        </ng-option>
      </ng-select>
    </div>

    <div *ngIf="showSortBy()" class="form-group">
      <label
        for="defaultSortInput"
        [innerText]="messages.DASHBOARD_DEFAULT_SORT">
      </label>
      <ng-select
        id="defaultSortInput"
        class="settings-select"
        [clearable]="false"
        [(ngModel)]="currentTableLayout.defaultSortBy">
        <ng-container *ngFor="let column of taskViewColumEnum | keyvalue">
          <ng-option
            *ngIf="column.value !== 'ORIGIN_USER' || show52Features"
            [value]="taskViewColumEnum[column.key]"
            [innerText]="taskViewColumEnum[column.key] | columnNamePipe">
          </ng-option>
        </ng-container>
      </ng-select>
    </div>

    <div *ngIf="showAsc()" class="form-group">
      <div>
        <button
          class="btn btn-outline-primary pe-4 ps-4"
          [ngClass]="{'active': !!currentTableLayout.defaultAsc}"
          (click)="currentTableLayout.defaultAsc = true"
          [innerText]="messages.DASHBOARD_ASC">
        </button>
        <button
          class="btn btn-outline-primary ms-1 pe-4 ps-4"
          [ngClass]="{'active': !currentTableLayout.defaultAsc}"
          (click)="currentTableLayout.defaultAsc = false"
          [innerText]="messages.DASHBOARD_DESC">
        </button>
      </div>
    </div>

    <div *ngIf="showFilter()" class="form-group">
      <label
        for="defaultFilterInput"
        [innerText]="messages.DASHBOARD_DEFAULT_FILTER">
      </label>
      <ng-select
        id="defaultFilterInput"
        class="settings-select"
        [(ngModel)]="userPreferences.currentFilter"
        [compareWith]="compareByIdFn"
        [searchable]="false"
        clearable="true"
        [placeholder]="commonMessages.NO_VALUE"
        [notFoundText]="commonMessages.NOT_FOUND">
        <ng-option
          *ngFor="let filter of filters"
          [value]="filter"
          [innerText]="filter.filterName">
        </ng-option>
      </ng-select>
    </div>
  </div>
  <div class="w-100">
    <h5
      class="fw-bold"
      [innerText]="messages.DASHBOARD_SORT_ELEMENTS">
    </h5>

    <div class="w-100 d-flex flex-row m-0 p-0" *ngIf="show52Features">
      <div class="w-50 max-width-50 pe-3"></div>
      <div class="w-50 max-width-50 ps-3">
        <div class="form-group">
          <label
            for="metadataList"
            [innerText]="typologyMessages.LINK_METADATA_">
          </label>

          <div class="d-flex flex-row">
            <ng-select
              class="d-grid w-100"
              id="metadataList"
              [title]="messages.SELECT_METADATA_TO_ADD"
              [items]="filteredMetadataList"
              [(ngModel)]="selectedMetadata"
              [placeholder]="metadataMessages.METADATA_SEARCH_PLACEHOLDER"
              [notFoundText]="commonMessages.NOT_FOUND"
              [clearAllText]="commonMessages.CLEAR"
              [disabled]="!uniqueTenantId"
              [ngbTooltip]="messages.METADATA_DISABLED_WHEN_USER_ASSOCIATED_TO_MULTIPLE_TENANTS"
              [disableTooltip]="!!uniqueTenantId"
              [multiple]="false"
              [clearable]="true"
              [searchFn]="searchMetadata"
              [ngModelOptions]="{standalone: true}">

              <ng-template let-item="item" ng-option-tmp>
                {{ item.name | namePipe }}
              </ng-template>

              <ng-template let-item="item" ng-label-tmp>
                <span class="ng-value-label" [innerText]="item.name"></span>
              </ng-template>

            </ng-select>
            <span
              class="btn-container"
              [ngbTooltip]="messages.MAX_COLUMNS_IN_DASHBOARD_REACHED"
              [disableTooltip]="!(usedColumns?.length >= MAX_COLUMNS_IN_DASHBOARD)">
              <button
                type="button"
                class="btn btn-sm btn-outline-primary ms-2 text-nowrap"
                [title]="messages.ADD_METADATA_TO_COLUMNS"
                [disabled]="!selectedMetadata || usedColumns?.length >= MAX_COLUMNS_IN_DASHBOARD"
                (click)="onAddMetadataButtonClicked()">
                <fa-icon [icon]="commonIcons.ADD_ICON"></fa-icon>
                {{ commonMessages.ADD }}
              </button>
            </span>
          </div>
        </div>
      </div>
    </div>

    <div class="h-100 w-100 d-flex flex-row m-0 p-0">

      <div class="w-50 max-width-50 pe-3">
        <span [innerText]="messages.DASHBOARD_AVAILABLE_COLUMNS"></span>

        <div class="w-100 list-group rounded-0 list-striped border-top border-bottom">
          <ng-container
            *ngFor="let column of availableColumns; let i = index">
            <div class="d-flex justify-content-between list-group-item border-0 no-pointer"
                 *ngIf="column.id !== 'ORIGIN_USER' || show52Features">
              <span [innerText]="column.id | columnNamePipe"></span>
              <ng-container *ngIf="usedColumns?.length >= MAX_COLUMNS_IN_DASHBOARD">

                <fa-icon
                  class="pointer disabled fa-disabled"
                  [ngbTooltip]="messages.MAX_COLUMNS_IN_DASHBOARD_REACHED"
                  [disableTooltip]="!(usedColumns?.length >= MAX_COLUMNS_IN_DASHBOARD)"
                  [icon]="commonIcons.ADD_ICON">
                </fa-icon>
              </ng-container>
              <ng-container *ngIf="usedColumns?.length < MAX_COLUMNS_IN_DASHBOARD">
                <fa-icon
                  class="text-primary pointer"
                  [icon]="commonIcons.ADD_ICON"
                  opacity="0.3"
                  (click)="addToUsedColumns(i)">
                </fa-icon>
              </ng-container>
            </div>
          </ng-container>
        </div>
      </div>

      <div class="w-50 max-width-50 ps-3">
        <div class="w-100 d-flex m-0 flex-row justify-content-between">
          <span [innerText]="messages.DASHBOARD_USED_COLUMNS"></span>
          <span
            class="me-3"
            [innerText]="messages.DASHBOARD_ORDER">
          </span>
        </div>
        <div
          cdkDropList
          class="w-100 list-group rounded-0 list-striped border-top border-bottom"
          (cdkDropListDropped)="drop($event)">
          <ng-container *ngFor="let column of usedColumns">
            <div cdkDragBoundary=".list-striped"
                 class="d-flex justify-content-between list-group-item border-0 no-pointer"
                 *ngIf="column.id !== 'ORIGIN_USER' || show52Features"
                 cdkDrag>
              <div class="d-flex w-100">
                <fa-icon
                  class="me-3 delete-icon"
                  [ngClass]="isColumnDeletable(column) ? 'pointer' : 'disabled transparent'"
                  [title]="commonMessages.DELETE"
                  [icon]="commonIcons.DELETE_ICON"
                  (click)="removeFromUsedColumns(column)">
                </fa-icon>
                <div
                  *ngIf="column.type === columnTypeEnum.ClassAttribute"
                  [innerText]="column.id | columnNamePipe"
                  class="w-100">
                </div>
                <div
                  *ngIf="column.type === columnTypeEnum.Metadata"
                  [innerText]="column.metadata?.name | namePipe"
                  class="w-100 text-nowrap overflow-hidden text-overflow-ellipsis">
                </div>
                <!-- TODO wait for design -->
                <div
                  *ngIf="column.type === columnTypeEnum.Metadata"
                  [innerText]="'(Métadonnée)'"
                  class="fst-italic text-size-small text-dark ms-2">
                </div>
                <div
                  class="example-handle ms-2"
                  cdkDragHandle>
                  <fa-icon
                    class="text-primary"
                    [icon]="gripHorizontalIcon">
                  </fa-icon>
                </div>
              </div>
            </div>
          </ng-container>
        </div>
      </div>
    </div>
  </div>
</div>
